<%@ WebHandler Language="C#" Class="CodePlex.GpsTracker.Web.GetGpx" %>
//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
using System;
using System.Web;
using System.Text.RegularExpressions;
using CodePlex.GpsTracker.DatabaseLayer;

namespace CodePlex.GpsTracker.Web
{
    public class GetGpx : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            string guid = context.Request.Params["id"];

            if (guid != null && Regex.IsMatch(guid, "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$"))
            {
                context.Response.ContentType = "text/xml";
                context.Response.Write("<?xml version=\"1.0\" encoding=\"utf-8\" ?>");
                context.Response.Write(GpsDataStoreDatabaseLayer.GetGpxByGuid(guid));
            }
            else
            {
                context.Response.StatusCode = 406; // Not Acceptable
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }

    } 
}